#ifndef _NATIVE_FUNS_H
#define _NATIVE_FUNS_H

#include <stdlib.h>
#include <stdbool.h>

#include "lisp_types.h"
#include "lisp_string.h"
#include "main.h"

void lisp_add(lisp_cons* cons, lisp_value* value);
void lisp_sub(lisp_cons* cons, lisp_value* value);
void lisp_mul(lisp_cons* cons, lisp_value* value);
void lisp_div(lisp_cons* cons, lisp_value* value);
void lisp_intdiv(lisp_cons* cons, lisp_value* value);

void lisp_not(lisp_cons* cons, lisp_value* value);
void lisp_or(lisp_cons* cons, lisp_value* value);
void lisp_and(lisp_cons* cons, lisp_value* value);

void lisp_eq(lisp_cons* cons, lisp_value* value);
void lisp_num_eq(lisp_cons* cons, lisp_value* value);
void lisp_num_lt(lisp_cons* cons, lisp_value* value);
void lisp_num_gt(lisp_cons* cons, lisp_value* value);
void lisp_num_le(lisp_cons* cons, lisp_value* value);
void lisp_num_ge(lisp_cons* cons, lisp_value* value);

void lisp_type_of(lisp_cons* cons, lisp_value* value);
void lisp_addr_of(lisp_cons* cons, lisp_value* value);

void init_native_funs();
#endif
